package com.tzld.piaoquan.recommend.server.implement.recall;


import com.tzld.piaoquan.recommend.server.framework.candidiate.Candidate;
import com.tzld.piaoquan.recommend.server.framework.common.User;
import com.tzld.piaoquan.recommend.server.framework.recaller.AbstractFilter;
import com.tzld.piaoquan.recommend.server.framework.recaller.FilterConfigInfo;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;
import com.tzld.piaoquan.recommend.server.model.Video;
import com.tzld.piaoquan.recommend.server.service.PreViewedService;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Set;

public class PreViewedFilter extends AbstractFilter<Video> {

    @Autowired
    private PreViewedService preViewedService;

    public PreViewedFilter(FilterConfigInfo filterConfigInfo,
                           RecommendRequest recommendRequest,
                           User user) {
        super(filterConfigInfo, recommendRequest, user);

    }

    @Override
    public void doFilter(Candidate candidate, List<Video> list) {
        if (StringUtils.isBlank(user.getMid())
                || CollectionUtils.isEmpty(list)) {
            return;
        }
        Set<Long> preViewedVideoIds = preViewedService.getVideoIds(this.requestContext.getAppType(), user.getMid());
        if (CollectionUtils.isEmpty(preViewedVideoIds)) {
            return;
        }
        list.removeIf(video -> preViewedVideoIds.contains(video.getVideoId()));
    }



}




